# include "stdio.h"
# define U(x) ((x)&0377)
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX 200
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern unsigned char yytext[];
int yymorfg;
extern unsigned char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
/**********************************************************************
 errLog.lex: error log parser. Reads an ascii error log and extracts
             error class or category that defines the type of device
             that generated the error and the time when the error occurred.
	     This information is written on a file which is going to be used
             by the DFT program.
 Author: Carol Hernandez
 Followed by Ying : Dec. 18, 1997
 Comments:
	     The error classes identified are architecture independent and 
             are defined as hardware related and software related errors in:
		 /usr/sys/include/dec/binlog/binlog.h
	     If more details about the device that caused the error are needed,
	     the subid_type, subid_ctldevtype, subid_num, and/or subid_unitnum
	     can be also obtained from the error log. I am not sure which 
	     fields in the error log correspond to those features. Maybe 
	     SYSTYPE, CLASS, SUBSYSTEM. All these fields are optional, may
	     or may not apply to the device causing the error, and are 
	     architecture dependent. The definitions for alpha and other
	     digital machines are given in /usr/sys/include/dec/binlog/errlog.h
*****************************************************************************/
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>

int       code;
char      *date;
struct    tm t;
time_t    errTime;
FILE      *file, *out_fd;

extern void sendErrorInfo(int code, time_t errTime);

# define ENTRY 2
# define CLASS 4
# define TIMESTAMP 6
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
       { ; }
break;
case 2:
   ;
break;
case 3:
    ;
break;
case 4:
case 5:
   { BEGIN ENTRY; }
break;
case 6:
{ BEGIN CLASS; }
break;
case 7:
{  BEGIN TIMESTAMP;  }
break;
case 8:
 { 
	   yytext[yyleng-1]='\0';
	   code = atoi(yytext);
	   switch (code) {
	   case 100: 
		code = 0;  /* CPU */
		break;
	   case 101: 
		code = 1;  /* Memory */
		break;
	   case 102: 
		code = 2;  /* Disk */
		break;
	   case 103: 
		code = 3;  /* Tapes */
		break;
	   case 104: 
		code = 4;  /* Device Controllers */
		break;
	   case 105: 
		code = 5;  /* Adapters */
		break;
	   case 106: 
		code = 6;  /* Buses */
		break;
	   case 107: 
		code = 7;  /* Stray Interrupts */
		break;
	   case 108: 
		code = 8;  /* Console Events */
		break;
	   case 109: 
		code = 9;  /* Stack Dumps */
		break;
	   case 198: 
		code = 10;  /* SWXCR RAID Controller Event */
		break;
	   case 199: 
		code = 11;  /* SCSI CAM Events */
		break;
	   case 201: 
		code = 12;  /* CI port-to-port driver event */
		break;
	   case 202: 
		code = 13;  /* System Communications Services */
		break;
           }
	   BEGIN ENTRY;
       }
break;
case 9:
	{
	   date = strdup(yytext);
	   if (strptime(date, "%a %b %d %T %Y", &t) == NULL) {
		printf("strptime: conversion of %s failed\n", date);
		exit(1);
	   }
	   errTime = mktime(&t);
	   if (errTime==-1) {
		printf("mktime:conversion from struct tm to time_t failed\n");
		exit(1);
	   }
	   sendErrorInfo(code, errTime);
	   BEGIN 0;
	  
     }
break;
case 10:
  { ; }
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */






int yyvstop[] = {
0,

10,
0,

3,
10,
0,

3,
10,
0,

1,
2,
4,
0,

10,
0,

10,
0,

10,
0,

10,
0,

3,
10,
0,

3,
10,
0,

10,
0,

3,
0,

3,
0,

2,
0,

4,
5,
0,

9,
0,

3,
0,

3,
0,

2,
9,
0,

4,
5,
9,
0,

5,
0,

5,
9,
0,

8,
0,

6,
0,

7,
0,
0};
# define YYTYPE unsigned char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,9,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,10,	1,0,	
2,11,	2,12,	3,0,	4,11,	
4,12,	5,0,	6,11,	6,12,	
7,16,	8,18,	8,12,	10,20,	
11,21,	11,22,	16,29,	17,31,	
7,17,	7,0,	13,23,	18,32,	
18,33,	23,23,	16,29,	16,30,	
27,39,	31,31,	13,23,	13,24,	
52,54,	23,23,	23,37,	25,25,	
36,36,	2,13,	10,20,	11,21,	
4,13,	1,9,	1,9,	6,13,	
32,32,	32,33,	8,19,	34,34,	
5,15,	19,34,	6,15,	40,44,	
51,53,	64,65,	0,0,	34,34,	
34,41,	19,34,	19,35,	7,16,	
7,16,	26,38,	14,26,	13,25,	
39,43,	16,29,	16,29,	46,48,	
47,49,	13,23,	13,23,	48,50,	
23,23,	23,23,	49,51,	3,14,	
42,45,	4,14,	14,27,	15,28,	
15,28,	15,28,	15,28,	15,28,	
15,28,	15,28,	15,28,	15,28,	
15,28,	38,42,	19,36,	43,46,	
45,47,	50,52,	34,34,	34,34,	
19,34,	19,34,	28,40,	28,40,	
28,40,	28,40,	28,40,	28,40,	
28,40,	28,40,	28,40,	28,40,	
53,55,	54,56,	55,57,	56,58,	
57,59,	58,60,	59,61,	60,62,	
61,63,	63,64,	65,66,	66,67,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-3,	yysvec+1,	0,	
yycrank+-4,	yysvec+1,	0,	
yycrank+-6,	yysvec+1,	0,	
yycrank+-7,	yysvec+1,	0,	
yycrank+-9,	yysvec+1,	0,	
yycrank+-19,	0,		0,	
yycrank+-12,	yysvec+7,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+14,	0,		yyvstop+3,
yycrank+15,	0,		yyvstop+6,
yycrank+0,	0,		yyvstop+9,
yycrank+-29,	0,		yyvstop+13,
yycrank+3,	0,		yyvstop+15,
yycrank+39,	0,		yyvstop+17,
yycrank+-25,	0,		yyvstop+19,
yycrank+-18,	yysvec+16,	yyvstop+21,
yycrank+-22,	yysvec+16,	yyvstop+24,
yycrank+-56,	0,		yyvstop+27,
yycrank+0,	yysvec+10,	yyvstop+29,
yycrank+0,	yysvec+11,	yyvstop+31,
yycrank+0,	0,		yyvstop+33,
yycrank+-32,	0,		0,	
yycrank+0,	0,		yyvstop+35,
yycrank+-1,	yysvec+13,	0,	
yycrank+2,	0,		0,	
yycrank+4,	0,		0,	
yycrank+58,	0,		0,	
yycrank+0,	yysvec+16,	0,	
yycrank+0,	0,		yyvstop+38,
yycrank+-28,	yysvec+16,	yyvstop+40,
yycrank+-43,	yysvec+16,	yyvstop+42,
yycrank+0,	0,		yyvstop+44,
yycrank+-54,	0,		0,	
yycrank+0,	0,		yyvstop+47,
yycrank+-2,	yysvec+19,	0,	
yycrank+0,	0,		yyvstop+51,
yycrank+12,	0,		0,	
yycrank+3,	0,		0,	
yycrank+13,	0,		0,	
yycrank+0,	0,		yyvstop+53,
yycrank+2,	0,		0,	
yycrank+13,	0,		0,	
yycrank+0,	0,		yyvstop+56,
yycrank+18,	0,		0,	
yycrank+6,	0,		0,	
yycrank+7,	0,		0,	
yycrank+1,	0,		0,	
yycrank+14,	0,		0,	
yycrank+17,	0,		0,	
yycrank+13,	0,		0,	
yycrank+8,	0,		0,	
yycrank+40,	0,		0,	
yycrank+33,	0,		0,	
yycrank+39,	0,		0,	
yycrank+30,	0,		0,	
yycrank+49,	0,		0,	
yycrank+41,	0,		0,	
yycrank+51,	0,		0,	
yycrank+54,	0,		0,	
yycrank+55,	0,		0,	
yycrank+0,	0,		yyvstop+58,
yycrank+57,	0,		0,	
yycrank+29,	0,		0,	
yycrank+47,	0,		0,	
yycrank+49,	0,		0,	
yycrank+0,	0,		yyvstop+60,
0,	0,	0};
struct yywork *yytop = yycrank+127;
struct yysvf *yybgin = yysvec+1;
unsigned char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
'0' ,'1' ,'1' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
0};
unsigned char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/*
 * (c) Copyright 1990, OPEN SOFTWARE FOUNDATION, INC.
 * ALL RIGHTS RESERVED
 */
/*
 * OSF/1 Release 1.0
*/
/*
#
# IBM CONFIDENTIAL
# Copyright International Business Machines Corp. 1989
# Unpublished Work
# All Rights Reserved
# Licensed Material - Property of IBM
#
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# 
*/
/* @(#)ncform	1.3  com/lib/l,3.1,8951 9/7/89 18:48:47 */
int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
unsigned char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
unsigned char yysbuf[YYLMAX];
unsigned char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	unsigned char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
            if (yylastch >= yytext + YYLMAX) {
                fprintf(yyout, "Maximum token length exceeded\n");
                yytext[YYLMAX] = 0;
                return 0;
            }
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( yyt > yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if(yyt < yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
                if (yyleng >= YYLMAX) {
                    fprintf(yyout, "Maximum token length exceeded\n");
                    yytext[YYLMAX] = 0;
                    return 0;
                }
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
yyback(p, m)
	int *p;
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	}
yyoutput(c)
  int c; {
	output(c);
	}
yyunput(c)
   int c; {
	unput(c);
	}
